
var prefixes=new Array();

prefixes["_nonempty_"]=validate_nonempty;
prefixes["_email_"]=validate_email;
prefixes["_date_"]=validate_date;
prefixes["_time_"]=validate_time;
prefixes["_datetime_"]=validate_datetime;
prefixes["_timestamp_"]=validate_timestamp;
prefixes["_number_"]=validate_number;
prefixes["_select_"]=validate_select;
prefixes["_radio_"]=validate_radio;
prefixes["_alphastring_"]=validate_alphastring;

warnings=new Array();
warnings["_nonempty_"]="   ";
warnings["_email_"]="  email";
warnings["_date_"]="  (DD.MM.YYYY)";
warnings["_time_"]="  (HH:MM)";
warnings["_datetime_"]="    (DD.MM.YYYY HH:MM)";
warnings["_timestamp_"]="    (DD.MM.YYYY HH:MM:SS)";
warnings["_number_"]="  ";
warnings["_select_"]="  ";
warnings["_radio_"]="  ";
warnings["_alphastring_"]=" (   )";

var GetPrefixPos=0;
var f;

function CheckMandatoryFields(form) {
	f=document.forms[form];
	var prefix;
	var c;
	var i;
	var flag=true;
	for(c=0;c<f.elements.length;c++) {
		while((prefix=getNextPrefix(f.elements[c].name))!="") 
		{
			if(!(prefixes[prefix](f.elements[c]))) {
				alert(warnings[prefix]);
				f.elements[c].focus();
				GetPrefixPos=0;
				return false;
			}
		}
	}
	
	while(flag) {
		flag=false;
		for(c=0;c<f.elements.length;c++) {
			for(prefix in prefixes) {
				if(f.elements[c].name.substring(0,prefix.length)==prefix) {
					f.elements[c].name=f.elements[c].name.substring(prefix.length,f.elements[c].name.length);
					flag=true;
				}
			}
		}
	} 
	return true;
}

function getNextPrefix(name) {
	var prefix;
	for(prefix in prefixes) {
		if(name.substring(GetPrefixPos,GetPrefixPos+prefix.length)==prefix) {
			GetPrefixPos+=prefix.length;
			return prefix;
		}
	}
	GetPrefixPos=0;
	prefix="";
	return prefix;
}

function validate_email(obj) {
	var i;
	var val=obj.value;
	var state=0;
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		// alert("state="+state+" val["+i+"]="+val.charAt(i));
		switch(state) {
			case 0: // waiting @
				if(val.charAt(i)=="@") {
					state=1;
				} else { 
					if(!is_alnum2(val.charAt(i))) return false;
				}
				break;
			case 1: // waiting .
				if(val.charAt(i)==".") {
					state=2;
				} else {
					if(!is_alnum2(val.charAt(i))) return false;
				}
				break;
			case 2: // waiting for some chars... or .
				if(is_alnum2(val.charAt(i))) {
					state=1;
				} else {
					return false;
				}
				break;
		}
	}
	if(state==1) return true;
	return false;
}
			
function validate_date(obj) {
	var i,state=0;
	var val=obj.value;
	var dd="",mm="",yyyy="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==".") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else dd+=val.charAt(i);
				break;
			case 1:
				if(val.charAt(i)==".") state=2;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mm+=val.charAt(i);
				break;
			case 2:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else yyyy+=val.charAt(i);
		}
	}
	if(state!=2) return false;

    if(dd.length != 2) return false; 
    if(mm.length != 2) return false;
    if(yyyy.length != 4) return false;

	if(isNaN(parseInt(dd)) || isNaN(parseInt(mm)) || isNaN(parseInt(yyyy))) return false;
	if(dd.length != 2 || mm.length !=2 || yyyy.length != 4) return false;
	if(parseInt(dd) < 0 || parseInt(mm) < 0 || parseInt(dd) > 31 || parseInt(mm) > 12) return false;
	return true;
}

function validate_time(obj) {
	var i,state=0;
	var val=obj.value;
	var hh="",mi="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==":") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else hh+=val.charAt(i);
				break;
			case 1:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mi+=val.charAt(i);
		}
	}
	if(state!=1) return false;
    if(hh.length != 2) return false;
	if(mi.length != 2) return false;

	if(isNaN(parseInt(hh)) || isNaN(parseInt(mi))) return false;
	if(parseInt(hh)>23 || parseInt(mi)<0 || parseInt(mi)>59) return false;
	return true;
}


function validate_datetime(obj) {
	var i,state=0;
	var val=obj.value;
	var dd="",mm="",yyyy="",hh="",mi="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==".") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else dd+=val.charAt(i);
				break;
			case 1:
				if(val.charAt(i)==".") state=2;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mm+=val.charAt(i);
				break;
			case 2:
				if(val.charAt(i)==" ") state=3;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else yyyy+=val.charAt(i);
				break;
			case 3:
				if(val.charAt(i)==":") state=4;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else hh+=val.charAt(i);
				break;
			case 4:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mi+=val.charAt(i);
		}
	}
	if(state!=4) return false;

    if(dd.length != 2) return false; 
    if(mm.length != 2) return false;
    if(yyyy.length != 4) return false;
    if(hh.length != 2) return false;
	if(mi.length != 2) return false;

	
	if(isNaN(parseInt(dd)) || isNaN(parseInt(mm)) || isNaN(parseInt(yyyy))) return false;
	if(parseInt(dd) < 0 || parseInt(mm) < 0 || parseInt(dd) > 31 || parseInt(mm) > 12) return false;
	if(isNaN(parseInt(hh)) || isNaN(parseInt(mi))) return false;
	if(parseInt(hh)>23 || parseInt(mi)<0 || parseInt(mi)>59) return false;
	return true;
}


function validate_timestamp(obj) {
	var i,state=0;
	var val=obj.value;
	var dd="",mm="",yyyy="",hh="",mi="",ss="";
	if(val=="") return true;
	for(i=0;i<val.length;i++) {
		switch(state) {
			case 0:
				if(val.charAt(i)==".") state=1;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else dd+=val.charAt(i);
				break;
			case 1:
				if(val.charAt(i)==".") state=2;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mm+=val.charAt(i);
				break;
			case 2:
				if(val.charAt(i)==" ") state=3;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else yyyy+=val.charAt(i);
				break;
			case 3:
				if(val.charAt(i)==":") state=4;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else hh+=val.charAt(i);
				break;
			case 4:
				if(val.charAt(i)==":") state=5;
				else if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else mi+=val.charAt(i);
				break;
			case 5:
				if("0123456789".indexOf(val.charAt(i))==-1) return false;
				else ss+=val.charAt(i);
		}
	}
	if(state!=5) return false;

    if(dd.length != 2) return false; 
    if(mm.length != 2) return false;
    if(yyyy.length != 4) return false;
    if(hh.length != 2) return false;
	if(mi.length != 2) return false;
    if(ss.length != 2) return false;
	
    if(isNaN(parseInt(dd)) || isNaN(parseInt(mm)) || isNaN(parseInt(yyyy))) return false;
	if(parseInt(dd) < 0 || parseInt(mm) < 0 || parseInt(dd) > 31 || parseInt(mm) > 12) return false;
	if(isNaN(parseInt(hh)) || isNaN(parseInt(mi)) || isNaN(parseInt(ss))) return false;
	if(parseInt(hh)>23 || parseInt(mi)<0 || parseInt(mi)>59 || parseInt(ss)<0 || parseInt(ss)>59) return false;
	return true;
}


function validate_nonempty(obj) {
	var val=obj.value;
	if(val=="") return false;
	return true;
}

function validate_number(obj) {
	var val=obj.value;
	if(val=="") return true;
	if(isNaN(parseFloat(val))) return false;
	return true;
}

function validate_select(obj) {
	var val=obj.options[obj.selectedIndex].value;
	if(val==-1 || val=="") return false;
	return true;
}

function validate_radio(obj) {
	obj = f[obj.name];
  	for (var i = 0;i<obj.length; i++) 
	{
   		if (obj[i].checked) return true;
	}
        return false;
}

function validate_alphastring(obj) {
	var val=obj.value;
	for(i=0;i<val.length;i++) {
        	if(!is_alpha(val.charAt(i))&&!is_number(val.charAt(i))&&!is_addsymb(val.charAt(i))) return false;
	}
	return true;
}


function is_alpha(c) {
	if("qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM".indexOf(c)!=-1) return true;
	return false;
}

function is_number(c) {
	if("0123456789".indexOf(c)!=-1) return true;
	else return false;
}

function is_alnum(c) {
	if(is_alpha(c) || is_number(c)) return true;
	return false;
}		

function is_alnum2(c) {
	if(is_alnum(c) || c=="_" || c=="-" || c==".") return true;
	return false;
}		

function is_addsymb(c) {
	if("_-\.\ ".indexOf(c)!=-1) return true;
	else return false;
}
